-------------------------------------------------------------
--Menus
-------------------------------------------------------------
renoise.tool():add_menu_entry {
  name = "Instrument Box:Convert Notes in:Track in Pattern",
  invoke = function() change()
  end
}

renoise.tool():add_menu_entry {
  name = "Instrument Box:Convert Notes in:Track",
  invoke = function() change_all()
  end
}

renoise.tool():add_menu_entry {
  name = "Instrument Box:Convert Notes in:Selection",
  invoke = function() change_selection()
  end
}


-------------------------------------------------------------
--Key Bindings
-------------------------------------------------------------
renoise.tool():add_keybinding {
  name = "Global:Tools:Convert (Track in Pattern) Instruments to Currently Selected",
  invoke = function() change() end
}

renoise.tool():add_keybinding {
  name = "Global:Tools:Convert (Whole Track) Instruments to Currently Selected",
  invoke = function() change_all() end
}

renoise.tool():add_keybinding {
  name = "Global:Tools:Convert (Selection in Pattern) Instruments to Currently Selected",
  invoke = function() change_selection() end
}

-----------------------------------------------------------------
--main(1) [Pattern Track]
-----------------------------------------------------------------

function change()

local pattern_iter = renoise.song().pattern_iterator
local track_index = renoise.song().selected_track_index
local pattern_index = renoise.song().selected_pattern_index
local inst_number = renoise.song().selected_instrument_index

-- Zero is returned when send/ master selected
if  renoise.song().tracks[track_index].visible_note_columns == 0 then
  return
end
 
--iterate:
--over "track in pattern" and change instrument values of all notes 
for pos,line in pattern_iter:note_columns_in_pattern_track(pattern_index,track_index) do
  
  if line.instrument_value ~= 255 then
    line.instrument_value = (inst_number - 1)
  end
end
                    
renoise.app():show_status("Convert Inst. no. Tool: (Instruments Changed in \"Track in Pattern\")")   
end --main

-----------------------------------------------------------------------
--main(2) [Whole track]
-----------------------------------------------------------------------
function change_all()

local pattern_iter = renoise.song().pattern_iterator
local track_index = renoise.song().selected_track_index
local inst_number = renoise.song().selected_instrument_index

-- Zero is returned when send/ master selected
if  renoise.song().tracks[track_index].visible_note_columns == 0 then
  return
end
 
--iterate:
--over "track in pattern" and change instrument values of all notes 
for pos,line in pattern_iter:note_columns_in_track(track_index) do
  
  if line.instrument_value ~= 255 then
    line.instrument_value = (inst_number - 1)
  end
end
                    
renoise.app():show_status("Convert Inst. no. Tool: (Instruments Changed in \"Track\")")    
end --main



-----------------------------------------------------------------------
--main(3) [Pattern Selection]
-----------------------------------------------------------------------
function change_selection()

local pattern_iter = renoise.song().pattern_iterator
local track_index = renoise.song().selected_track_index
local pattern_index = renoise.song().selected_pattern_index
local inst_number = renoise.song().selected_instrument_index

-- Zero is returned when send/ master selected
if  renoise.song().tracks[track_index].visible_note_columns == 0 then
  return
end
 
--iterate:
--over "Pattern" and change instrument values of all notes 
for pos,line in pattern_iter:note_columns_in_pattern(pattern_index,track_index) do
    
    if line.is_selected then --only selection
      if line.instrument_value ~= 255 then
        line.instrument_value = (inst_number - 1)
      end
    end  
  
end
                    
renoise.app():show_status("Convert Inst. no. Tool: (Instruments Changed in \"Selection\")")    
end --main









